<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGeneralReportElements ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGeneralReportElements
 * @subpackage Arrays
 */
class ArrayOfGeneralReportElements extends AbstractStructArrayBase
{
    /**
     * The GeneralReportElements
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GeneralReportElements[]
     */
    public $GeneralReportElements;
    /**
     * Constructor method for ArrayOfGeneralReportElements
     * @uses ArrayOfGeneralReportElements::setGeneralReportElements()
     * @param \StructType\GeneralReportElements[] $generalReportElements
     */
    public function __construct(array $generalReportElements = array())
    {
        $this
            ->setGeneralReportElements($generalReportElements);
    }
    /**
     * Get GeneralReportElements value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GeneralReportElements[]|null
     */
    public function getGeneralReportElements()
    {
        return isset($this->GeneralReportElements) ? $this->GeneralReportElements : null;
    }
    /**
     * Set GeneralReportElements value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GeneralReportElements[] $generalReportElements
     * @return \ArrayType\ArrayOfGeneralReportElements
     */
    public function setGeneralReportElements(array $generalReportElements = array())
    {
        foreach ($generalReportElements as $arrayOfGeneralReportElementsGeneralReportElementsItem) {
            // validation for constraint: itemType
            if (!$arrayOfGeneralReportElementsGeneralReportElementsItem instanceof \StructType\GeneralReportElements) {
                throw new \InvalidArgumentException(sprintf('The GeneralReportElements property can only contain items of \StructType\GeneralReportElements, "%s" given', is_object($arrayOfGeneralReportElementsGeneralReportElementsItem) ? get_class($arrayOfGeneralReportElementsGeneralReportElementsItem) : gettype($arrayOfGeneralReportElementsGeneralReportElementsItem)), __LINE__);
            }
        }
        if (is_null($generalReportElements) || (is_array($generalReportElements) && empty($generalReportElements))) {
            unset($this->GeneralReportElements);
        } else {
            $this->GeneralReportElements = $generalReportElements;
        }
        return $this;
    }
    /**
     * Add item to GeneralReportElements value
     * @throws \InvalidArgumentException
     * @param \StructType\GeneralReportElements $item
     * @return \ArrayType\ArrayOfGeneralReportElements
     */
    public function addToGeneralReportElements(\StructType\GeneralReportElements $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GeneralReportElements) {
            throw new \InvalidArgumentException(sprintf('The GeneralReportElements property can only contain items of \StructType\GeneralReportElements, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GeneralReportElements[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GeneralReportElements|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GeneralReportElements|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GeneralReportElements|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GeneralReportElements|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GeneralReportElements|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GeneralReportElements
     */
    public function getAttributeName()
    {
        return 'GeneralReportElements';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGeneralReportElements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
