<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CanBusOBDGeneralReportElements StructType
 * @subpackage Structs
 */
class CanBusOBDGeneralReportElements extends AbstractStructBase
{
    /**
     * The Date_Time
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Date_Time;
    /**
     * The Value
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Value;
    /**
     * The Record_No
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Record_No;
    /**
     * The Device_No
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Device_No;
    /**
     * The License_Plate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $License_Plate;
    /**
     * The Driver
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Driver;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The Address
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address;
    /**
     * Constructor method for CanBusOBDGeneralReportElements
     * @uses CanBusOBDGeneralReportElements::setDate_Time()
     * @uses CanBusOBDGeneralReportElements::setValue()
     * @uses CanBusOBDGeneralReportElements::setRecord_No()
     * @uses CanBusOBDGeneralReportElements::setDevice_No()
     * @uses CanBusOBDGeneralReportElements::setLicense_Plate()
     * @uses CanBusOBDGeneralReportElements::setDriver()
     * @uses CanBusOBDGeneralReportElements::setType()
     * @uses CanBusOBDGeneralReportElements::setAddress()
     * @param string $date_Time
     * @param float $value
     * @param string $record_No
     * @param string $device_No
     * @param string $license_Plate
     * @param string $driver
     * @param string $type
     * @param string $address
     */
    public function __construct($date_Time = null, $value = null, $record_No = null, $device_No = null, $license_Plate = null, $driver = null, $type = null, $address = null)
    {
        $this
            ->setDate_Time($date_Time)
            ->setValue($value)
            ->setRecord_No($record_No)
            ->setDevice_No($device_No)
            ->setLicense_Plate($license_Plate)
            ->setDriver($driver)
            ->setType($type)
            ->setAddress($address);
    }
    /**
     * Get Date_Time value
     * @return string
     */
    public function getDate_Time()
    {
        return $this->Date_Time;
    }
    /**
     * Set Date_Time value
     * @param string $date_Time
     * @return \StructType\CanBusOBDGeneralReportElements
     */
    public function setDate_Time($date_Time = null)
    {
        // validation for constraint: string
        if (!is_null($date_Time) && !is_string($date_Time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($date_Time)), __LINE__);
        }
        $this->Date_Time = $date_Time;
        return $this;
    }
    /**
     * Get Value value
     * @return float
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param float $value
     * @return \StructType\CanBusOBDGeneralReportElements
     */
    public function setValue($value = null)
    {
        $this->Value = $value;
        return $this;
    }
    /**
     * Get Record_No value
     * @return string|null
     */
    public function getRecord_No()
    {
        return $this->Record_No;
    }
    /**
     * Set Record_No value
     * @param string $record_No
     * @return \StructType\CanBusOBDGeneralReportElements
     */
    public function setRecord_No($record_No = null)
    {
        // validation for constraint: string
        if (!is_null($record_No) && !is_string($record_No)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($record_No)), __LINE__);
        }
        $this->Record_No = $record_No;
        return $this;
    }
    /**
     * Get Device_No value
     * @return string|null
     */
    public function getDevice_No()
    {
        return $this->Device_No;
    }
    /**
     * Set Device_No value
     * @param string $device_No
     * @return \StructType\CanBusOBDGeneralReportElements
     */
    public function setDevice_No($device_No = null)
    {
        // validation for constraint: string
        if (!is_null($device_No) && !is_string($device_No)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($device_No)), __LINE__);
        }
        $this->Device_No = $device_No;
        return $this;
    }
    /**
     * Get License_Plate value
     * @return string|null
     */
    public function getLicense_Plate()
    {
        return $this->License_Plate;
    }
    /**
     * Set License_Plate value
     * @param string $license_Plate
     * @return \StructType\CanBusOBDGeneralReportElements
     */
    public function setLicense_Plate($license_Plate = null)
    {
        // validation for constraint: string
        if (!is_null($license_Plate) && !is_string($license_Plate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($license_Plate)), __LINE__);
        }
        $this->License_Plate = $license_Plate;
        return $this;
    }
    /**
     * Get Driver value
     * @return string|null
     */
    public function getDriver()
    {
        return $this->Driver;
    }
    /**
     * Set Driver value
     * @param string $driver
     * @return \StructType\CanBusOBDGeneralReportElements
     */
    public function setDriver($driver = null)
    {
        // validation for constraint: string
        if (!is_null($driver) && !is_string($driver)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($driver)), __LINE__);
        }
        $this->Driver = $driver;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\CanBusOBDGeneralReportElements
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param string $address
     * @return \StructType\CanBusOBDGeneralReportElements
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($address)), __LINE__);
        }
        $this->Address = $address;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CanBusOBDGeneralReportElements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
