<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GeneralReportElements StructType
 * @subpackage Structs
 */
class GeneralReportElements extends AbstractStructBase
{
    /**
     * The Record_No
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Record_No;
    /**
     * The Date_Time
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Date_Time;
    /**
     * The Speed_kmh
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Speed_kmh;
    /**
     * The Temperature
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Temperature;
    /**
     * The Sensor
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Sensor;
    /**
     * The Distance
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Distance;
    /**
     * The Device_No
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Device_No;
    /**
     * The License_Plate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $License_Plate;
    /**
     * The Driver
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Driver;
    /**
     * The Driver_Identification_Unit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Driver_Identification_Unit;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The Address
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address;
    /**
     * The iButtonNo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $iButtonNo;
    /**
     * The Latitude
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Latitude;
    /**
     * The Longitude
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Longitude;
    /**
     * The Geographical_Region
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Geographical_Region;
    /**
     * The Pause_Duration
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Pause_Duration;
    /**
     * The Idling_Duration
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Idling_Duration;
    /**
     * The Ignition_On_Duration
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Ignition_On_Duration;
    /**
     * Constructor method for GeneralReportElements
     * @uses GeneralReportElements::setRecord_No()
     * @uses GeneralReportElements::setDate_Time()
     * @uses GeneralReportElements::setSpeed_kmh()
     * @uses GeneralReportElements::setTemperature()
     * @uses GeneralReportElements::setSensor()
     * @uses GeneralReportElements::setDistance()
     * @uses GeneralReportElements::setDevice_No()
     * @uses GeneralReportElements::setLicense_Plate()
     * @uses GeneralReportElements::setDriver()
     * @uses GeneralReportElements::setDriver_Identification_Unit()
     * @uses GeneralReportElements::setType()
     * @uses GeneralReportElements::setAddress()
     * @uses GeneralReportElements::setIButtonNo()
     * @uses GeneralReportElements::setLatitude()
     * @uses GeneralReportElements::setLongitude()
     * @uses GeneralReportElements::setGeographical_Region()
     * @uses GeneralReportElements::setPause_Duration()
     * @uses GeneralReportElements::setIdling_Duration()
     * @uses GeneralReportElements::setIgnition_On_Duration()
     * @param int $record_No
     * @param string $date_Time
     * @param float $speed_kmh
     * @param float $temperature
     * @param int $sensor
     * @param float $distance
     * @param string $device_No
     * @param string $license_Plate
     * @param string $driver
     * @param string $driver_Identification_Unit
     * @param string $type
     * @param string $address
     * @param string $iButtonNo
     * @param string $latitude
     * @param string $longitude
     * @param string $geographical_Region
     * @param string $pause_Duration
     * @param string $idling_Duration
     * @param string $ignition_On_Duration
     */
    public function __construct($record_No = null, $date_Time = null, $speed_kmh = null, $temperature = null, $sensor = null, $distance = null, $device_No = null, $license_Plate = null, $driver = null, $driver_Identification_Unit = null, $type = null, $address = null, $iButtonNo = null, $latitude = null, $longitude = null, $geographical_Region = null, $pause_Duration = null, $idling_Duration = null, $ignition_On_Duration = null)
    {
        $this
            ->setRecord_No($record_No)
            ->setDate_Time($date_Time)
            ->setSpeed_kmh($speed_kmh)
            ->setTemperature($temperature)
            ->setSensor($sensor)
            ->setDistance($distance)
            ->setDevice_No($device_No)
            ->setLicense_Plate($license_Plate)
            ->setDriver($driver)
            ->setDriver_Identification_Unit($driver_Identification_Unit)
            ->setType($type)
            ->setAddress($address)
            ->setIButtonNo($iButtonNo)
            ->setLatitude($latitude)
            ->setLongitude($longitude)
            ->setGeographical_Region($geographical_Region)
            ->setPause_Duration($pause_Duration)
            ->setIdling_Duration($idling_Duration)
            ->setIgnition_On_Duration($ignition_On_Duration);
    }
    /**
     * Get Record_No value
     * @return int
     */
    public function getRecord_No()
    {
        return $this->Record_No;
    }
    /**
     * Set Record_No value
     * @param int $record_No
     * @return \StructType\GeneralReportElements
     */
    public function setRecord_No($record_No = null)
    {
        // validation for constraint: int
        if (!is_null($record_No) && !is_numeric($record_No)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($record_No)), __LINE__);
        }
        $this->Record_No = $record_No;
        return $this;
    }
    /**
     * Get Date_Time value
     * @return string
     */
    public function getDate_Time()
    {
        return $this->Date_Time;
    }
    /**
     * Set Date_Time value
     * @param string $date_Time
     * @return \StructType\GeneralReportElements
     */
    public function setDate_Time($date_Time = null)
    {
        // validation for constraint: string
        if (!is_null($date_Time) && !is_string($date_Time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($date_Time)), __LINE__);
        }
        $this->Date_Time = $date_Time;
        return $this;
    }
    /**
     * Get Speed_kmh value
     * @return float
     */
    public function getSpeed_kmh()
    {
        return $this->Speed_kmh;
    }
    /**
     * Set Speed_kmh value
     * @param float $speed_kmh
     * @return \StructType\GeneralReportElements
     */
    public function setSpeed_kmh($speed_kmh = null)
    {
        $this->Speed_kmh = $speed_kmh;
        return $this;
    }
    /**
     * Get Temperature value
     * @return float
     */
    public function getTemperature()
    {
        return $this->Temperature;
    }
    /**
     * Set Temperature value
     * @param float $temperature
     * @return \StructType\GeneralReportElements
     */
    public function setTemperature($temperature = null)
    {
        $this->Temperature = $temperature;
        return $this;
    }
    /**
     * Get Sensor value
     * @return int
     */
    public function getSensor()
    {
        return $this->Sensor;
    }
    /**
     * Set Sensor value
     * @param int $sensor
     * @return \StructType\GeneralReportElements
     */
    public function setSensor($sensor = null)
    {
        // validation for constraint: int
        if (!is_null($sensor) && !is_numeric($sensor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sensor)), __LINE__);
        }
        $this->Sensor = $sensor;
        return $this;
    }
    /**
     * Get Distance value
     * @return float
     */
    public function getDistance()
    {
        return $this->Distance;
    }
    /**
     * Set Distance value
     * @param float $distance
     * @return \StructType\GeneralReportElements
     */
    public function setDistance($distance = null)
    {
        $this->Distance = $distance;
        return $this;
    }
    /**
     * Get Device_No value
     * @return string|null
     */
    public function getDevice_No()
    {
        return $this->Device_No;
    }
    /**
     * Set Device_No value
     * @param string $device_No
     * @return \StructType\GeneralReportElements
     */
    public function setDevice_No($device_No = null)
    {
        // validation for constraint: string
        if (!is_null($device_No) && !is_string($device_No)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($device_No)), __LINE__);
        }
        $this->Device_No = $device_No;
        return $this;
    }
    /**
     * Get License_Plate value
     * @return string|null
     */
    public function getLicense_Plate()
    {
        return $this->License_Plate;
    }
    /**
     * Set License_Plate value
     * @param string $license_Plate
     * @return \StructType\GeneralReportElements
     */
    public function setLicense_Plate($license_Plate = null)
    {
        // validation for constraint: string
        if (!is_null($license_Plate) && !is_string($license_Plate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($license_Plate)), __LINE__);
        }
        $this->License_Plate = $license_Plate;
        return $this;
    }
    /**
     * Get Driver value
     * @return string|null
     */
    public function getDriver()
    {
        return $this->Driver;
    }
    /**
     * Set Driver value
     * @param string $driver
     * @return \StructType\GeneralReportElements
     */
    public function setDriver($driver = null)
    {
        // validation for constraint: string
        if (!is_null($driver) && !is_string($driver)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($driver)), __LINE__);
        }
        $this->Driver = $driver;
        return $this;
    }
    /**
     * Get Driver_Identification_Unit value
     * @return string|null
     */
    public function getDriver_Identification_Unit()
    {
        return $this->Driver_Identification_Unit;
    }
    /**
     * Set Driver_Identification_Unit value
     * @param string $driver_Identification_Unit
     * @return \StructType\GeneralReportElements
     */
    public function setDriver_Identification_Unit($driver_Identification_Unit = null)
    {
        // validation for constraint: string
        if (!is_null($driver_Identification_Unit) && !is_string($driver_Identification_Unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($driver_Identification_Unit)), __LINE__);
        }
        $this->Driver_Identification_Unit = $driver_Identification_Unit;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\GeneralReportElements
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param string $address
     * @return \StructType\GeneralReportElements
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($address)), __LINE__);
        }
        $this->Address = $address;
        return $this;
    }
    /**
     * Get iButtonNo value
     * @return string|null
     */
    public function getIButtonNo()
    {
        return $this->iButtonNo;
    }
    /**
     * Set iButtonNo value
     * @param string $iButtonNo
     * @return \StructType\GeneralReportElements
     */
    public function setIButtonNo($iButtonNo = null)
    {
        // validation for constraint: string
        if (!is_null($iButtonNo) && !is_string($iButtonNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iButtonNo)), __LINE__);
        }
        $this->iButtonNo = $iButtonNo;
        return $this;
    }
    /**
     * Get Latitude value
     * @return string|null
     */
    public function getLatitude()
    {
        return $this->Latitude;
    }
    /**
     * Set Latitude value
     * @param string $latitude
     * @return \StructType\GeneralReportElements
     */
    public function setLatitude($latitude = null)
    {
        // validation for constraint: string
        if (!is_null($latitude) && !is_string($latitude)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($latitude)), __LINE__);
        }
        $this->Latitude = $latitude;
        return $this;
    }
    /**
     * Get Longitude value
     * @return string|null
     */
    public function getLongitude()
    {
        return $this->Longitude;
    }
    /**
     * Set Longitude value
     * @param string $longitude
     * @return \StructType\GeneralReportElements
     */
    public function setLongitude($longitude = null)
    {
        // validation for constraint: string
        if (!is_null($longitude) && !is_string($longitude)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($longitude)), __LINE__);
        }
        $this->Longitude = $longitude;
        return $this;
    }
    /**
     * Get Geographical_Region value
     * @return string|null
     */
    public function getGeographical_Region()
    {
        return $this->Geographical_Region;
    }
    /**
     * Set Geographical_Region value
     * @param string $geographical_Region
     * @return \StructType\GeneralReportElements
     */
    public function setGeographical_Region($geographical_Region = null)
    {
        // validation for constraint: string
        if (!is_null($geographical_Region) && !is_string($geographical_Region)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($geographical_Region)), __LINE__);
        }
        $this->Geographical_Region = $geographical_Region;
        return $this;
    }
    /**
     * Get Pause_Duration value
     * @return string|null
     */
    public function getPause_Duration()
    {
        return $this->Pause_Duration;
    }
    /**
     * Set Pause_Duration value
     * @param string $pause_Duration
     * @return \StructType\GeneralReportElements
     */
    public function setPause_Duration($pause_Duration = null)
    {
        // validation for constraint: string
        if (!is_null($pause_Duration) && !is_string($pause_Duration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pause_Duration)), __LINE__);
        }
        $this->Pause_Duration = $pause_Duration;
        return $this;
    }
    /**
     * Get Idling_Duration value
     * @return string|null
     */
    public function getIdling_Duration()
    {
        return $this->Idling_Duration;
    }
    /**
     * Set Idling_Duration value
     * @param string $idling_Duration
     * @return \StructType\GeneralReportElements
     */
    public function setIdling_Duration($idling_Duration = null)
    {
        // validation for constraint: string
        if (!is_null($idling_Duration) && !is_string($idling_Duration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($idling_Duration)), __LINE__);
        }
        $this->Idling_Duration = $idling_Duration;
        return $this;
    }
    /**
     * Get Ignition_On_Duration value
     * @return string|null
     */
    public function getIgnition_On_Duration()
    {
        return $this->Ignition_On_Duration;
    }
    /**
     * Set Ignition_On_Duration value
     * @param string $ignition_On_Duration
     * @return \StructType\GeneralReportElements
     */
    public function setIgnition_On_Duration($ignition_On_Duration = null)
    {
        // validation for constraint: string
        if (!is_null($ignition_On_Duration) && !is_string($ignition_On_Duration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ignition_On_Duration)), __LINE__);
        }
        $this->Ignition_On_Duration = $ignition_On_Duration;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GeneralReportElements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
