<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetVehicleStatusElements StructType
 * @subpackage Structs
 */
class GetVehicleStatusElements extends AbstractStructBase
{
    /**
     * The GMT_Date_Time
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $GMT_Date_Time;
    /**
     * The Latitude
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Latitude;
    /**
     * The Longitude
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Longitude;
    /**
     * The Speed
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Speed;
    /**
     * The Device_No
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Device_No;
    /**
     * The Address
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address;
    /**
     * The Building_Region
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Building_Region;
    /**
     * Constructor method for GetVehicleStatusElements
     * @uses GetVehicleStatusElements::setGMT_Date_Time()
     * @uses GetVehicleStatusElements::setLatitude()
     * @uses GetVehicleStatusElements::setLongitude()
     * @uses GetVehicleStatusElements::setSpeed()
     * @uses GetVehicleStatusElements::setDevice_No()
     * @uses GetVehicleStatusElements::setAddress()
     * @uses GetVehicleStatusElements::setBuilding_Region()
     * @param string $gMT_Date_Time
     * @param float $latitude
     * @param float $longitude
     * @param float $speed
     * @param string $device_No
     * @param string $address
     * @param string $building_Region
     */
    public function __construct($gMT_Date_Time = null, $latitude = null, $longitude = null, $speed = null, $device_No = null, $address = null, $building_Region = null)
    {
        $this
            ->setGMT_Date_Time($gMT_Date_Time)
            ->setLatitude($latitude)
            ->setLongitude($longitude)
            ->setSpeed($speed)
            ->setDevice_No($device_No)
            ->setAddress($address)
            ->setBuilding_Region($building_Region);
    }
    /**
     * Get GMT_Date_Time value
     * @return string
     */
    public function getGMT_Date_Time()
    {
        return $this->GMT_Date_Time;
    }
    /**
     * Set GMT_Date_Time value
     * @param string $gMT_Date_Time
     * @return \StructType\GetVehicleStatusElements
     */
    public function setGMT_Date_Time($gMT_Date_Time = null)
    {
        // validation for constraint: string
        if (!is_null($gMT_Date_Time) && !is_string($gMT_Date_Time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($gMT_Date_Time)), __LINE__);
        }
        $this->GMT_Date_Time = $gMT_Date_Time;
        return $this;
    }
    /**
     * Get Latitude value
     * @return float
     */
    public function getLatitude()
    {
        return $this->Latitude;
    }
    /**
     * Set Latitude value
     * @param float $latitude
     * @return \StructType\GetVehicleStatusElements
     */
    public function setLatitude($latitude = null)
    {
        $this->Latitude = $latitude;
        return $this;
    }
    /**
     * Get Longitude value
     * @return float
     */
    public function getLongitude()
    {
        return $this->Longitude;
    }
    /**
     * Set Longitude value
     * @param float $longitude
     * @return \StructType\GetVehicleStatusElements
     */
    public function setLongitude($longitude = null)
    {
        $this->Longitude = $longitude;
        return $this;
    }
    /**
     * Get Speed value
     * @return float
     */
    public function getSpeed()
    {
        return $this->Speed;
    }
    /**
     * Set Speed value
     * @param float $speed
     * @return \StructType\GetVehicleStatusElements
     */
    public function setSpeed($speed = null)
    {
        $this->Speed = $speed;
        return $this;
    }
    /**
     * Get Device_No value
     * @return string|null
     */
    public function getDevice_No()
    {
        return $this->Device_No;
    }
    /**
     * Set Device_No value
     * @param string $device_No
     * @return \StructType\GetVehicleStatusElements
     */
    public function setDevice_No($device_No = null)
    {
        // validation for constraint: string
        if (!is_null($device_No) && !is_string($device_No)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($device_No)), __LINE__);
        }
        $this->Device_No = $device_No;
        return $this;
    }
    /**
     * Get Address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param string $address
     * @return \StructType\GetVehicleStatusElements
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($address)), __LINE__);
        }
        $this->Address = $address;
        return $this;
    }
    /**
     * Get Building_Region value
     * @return string|null
     */
    public function getBuilding_Region()
    {
        return $this->Building_Region;
    }
    /**
     * Set Building_Region value
     * @param string $building_Region
     * @return \StructType\GetVehicleStatusElements
     */
    public function setBuilding_Region($building_Region = null)
    {
        // validation for constraint: string
        if (!is_null($building_Region) && !is_string($building_Region)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($building_Region)), __LINE__);
        }
        $this->Building_Region = $building_Region;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetVehicleStatusElements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
