<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RegionAlarmElements StructType
 * @subpackage Structs
 */
class RegionAlarmElements extends AbstractStructBase
{
    /**
     * The Date_Time
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Date_Time;
    /**
     * The Record_No
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Record_No;
    /**
     * The Device_No
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Device_No;
    /**
     * The License_Plate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $License_Plate;
    /**
     * The Status
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Status;
    /**
     * The Region
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Region;
    /**
     * Constructor method for RegionAlarmElements
     * @uses RegionAlarmElements::setDate_Time()
     * @uses RegionAlarmElements::setRecord_No()
     * @uses RegionAlarmElements::setDevice_No()
     * @uses RegionAlarmElements::setLicense_Plate()
     * @uses RegionAlarmElements::setStatus()
     * @uses RegionAlarmElements::setRegion()
     * @param string $date_Time
     * @param string $record_No
     * @param string $device_No
     * @param string $license_Plate
     * @param string $status
     * @param string $region
     */
    public function __construct($date_Time = null, $record_No = null, $device_No = null, $license_Plate = null, $status = null, $region = null)
    {
        $this
            ->setDate_Time($date_Time)
            ->setRecord_No($record_No)
            ->setDevice_No($device_No)
            ->setLicense_Plate($license_Plate)
            ->setStatus($status)
            ->setRegion($region);
    }
    /**
     * Get Date_Time value
     * @return string
     */
    public function getDate_Time()
    {
        return $this->Date_Time;
    }
    /**
     * Set Date_Time value
     * @param string $date_Time
     * @return \StructType\RegionAlarmElements
     */
    public function setDate_Time($date_Time = null)
    {
        // validation for constraint: string
        if (!is_null($date_Time) && !is_string($date_Time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($date_Time)), __LINE__);
        }
        $this->Date_Time = $date_Time;
        return $this;
    }
    /**
     * Get Record_No value
     * @return string|null
     */
    public function getRecord_No()
    {
        return $this->Record_No;
    }
    /**
     * Set Record_No value
     * @param string $record_No
     * @return \StructType\RegionAlarmElements
     */
    public function setRecord_No($record_No = null)
    {
        // validation for constraint: string
        if (!is_null($record_No) && !is_string($record_No)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($record_No)), __LINE__);
        }
        $this->Record_No = $record_No;
        return $this;
    }
    /**
     * Get Device_No value
     * @return string|null
     */
    public function getDevice_No()
    {
        return $this->Device_No;
    }
    /**
     * Set Device_No value
     * @param string $device_No
     * @return \StructType\RegionAlarmElements
     */
    public function setDevice_No($device_No = null)
    {
        // validation for constraint: string
        if (!is_null($device_No) && !is_string($device_No)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($device_No)), __LINE__);
        }
        $this->Device_No = $device_No;
        return $this;
    }
    /**
     * Get License_Plate value
     * @return string|null
     */
    public function getLicense_Plate()
    {
        return $this->License_Plate;
    }
    /**
     * Set License_Plate value
     * @param string $license_Plate
     * @return \StructType\RegionAlarmElements
     */
    public function setLicense_Plate($license_Plate = null)
    {
        // validation for constraint: string
        if (!is_null($license_Plate) && !is_string($license_Plate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($license_Plate)), __LINE__);
        }
        $this->License_Plate = $license_Plate;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \StructType\RegionAlarmElements
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get Region value
     * @return string|null
     */
    public function getRegion()
    {
        return $this->Region;
    }
    /**
     * Set Region value
     * @param string $region
     * @return \StructType\RegionAlarmElements
     */
    public function setRegion($region = null)
    {
        // validation for constraint: string
        if (!is_null($region) && !is_string($region)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($region)), __LINE__);
        }
        $this->Region = $region;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RegionAlarmElements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
