<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SpeedAlarmElements StructType
 * @subpackage Structs
 */
class SpeedAlarmElements extends AbstractStructBase
{
    /**
     * The Date_Time
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Date_Time;
    /**
     * The Speed_kmh
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Speed_kmh;
    /**
     * The Record_No
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Record_No;
    /**
     * The Device_No
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Device_No;
    /**
     * The License_Plate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $License_Plate;
    /**
     * The Driver
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Driver;
    /**
     * The Address
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Address;
    /**
     * The Km_Counter
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Km_Counter;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * Constructor method for SpeedAlarmElements
     * @uses SpeedAlarmElements::setDate_Time()
     * @uses SpeedAlarmElements::setSpeed_kmh()
     * @uses SpeedAlarmElements::setRecord_No()
     * @uses SpeedAlarmElements::setDevice_No()
     * @uses SpeedAlarmElements::setLicense_Plate()
     * @uses SpeedAlarmElements::setDriver()
     * @uses SpeedAlarmElements::setAddress()
     * @uses SpeedAlarmElements::setKm_Counter()
     * @uses SpeedAlarmElements::setDescription()
     * @param string $date_Time
     * @param float $speed_kmh
     * @param string $record_No
     * @param string $device_No
     * @param string $license_Plate
     * @param string $driver
     * @param string $address
     * @param string $km_Counter
     * @param string $description
     */
    public function __construct($date_Time = null, $speed_kmh = null, $record_No = null, $device_No = null, $license_Plate = null, $driver = null, $address = null, $km_Counter = null, $description = null)
    {
        $this
            ->setDate_Time($date_Time)
            ->setSpeed_kmh($speed_kmh)
            ->setRecord_No($record_No)
            ->setDevice_No($device_No)
            ->setLicense_Plate($license_Plate)
            ->setDriver($driver)
            ->setAddress($address)
            ->setKm_Counter($km_Counter)
            ->setDescription($description);
    }
    /**
     * Get Date_Time value
     * @return string
     */
    public function getDate_Time()
    {
        return $this->Date_Time;
    }
    /**
     * Set Date_Time value
     * @param string $date_Time
     * @return \StructType\SpeedAlarmElements
     */
    public function setDate_Time($date_Time = null)
    {
        // validation for constraint: string
        if (!is_null($date_Time) && !is_string($date_Time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($date_Time)), __LINE__);
        }
        $this->Date_Time = $date_Time;
        return $this;
    }
    /**
     * Get Speed_kmh value
     * @return float
     */
    public function getSpeed_kmh()
    {
        return $this->Speed_kmh;
    }
    /**
     * Set Speed_kmh value
     * @param float $speed_kmh
     * @return \StructType\SpeedAlarmElements
     */
    public function setSpeed_kmh($speed_kmh = null)
    {
        $this->Speed_kmh = $speed_kmh;
        return $this;
    }
    /**
     * Get Record_No value
     * @return string|null
     */
    public function getRecord_No()
    {
        return $this->Record_No;
    }
    /**
     * Set Record_No value
     * @param string $record_No
     * @return \StructType\SpeedAlarmElements
     */
    public function setRecord_No($record_No = null)
    {
        // validation for constraint: string
        if (!is_null($record_No) && !is_string($record_No)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($record_No)), __LINE__);
        }
        $this->Record_No = $record_No;
        return $this;
    }
    /**
     * Get Device_No value
     * @return string|null
     */
    public function getDevice_No()
    {
        return $this->Device_No;
    }
    /**
     * Set Device_No value
     * @param string $device_No
     * @return \StructType\SpeedAlarmElements
     */
    public function setDevice_No($device_No = null)
    {
        // validation for constraint: string
        if (!is_null($device_No) && !is_string($device_No)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($device_No)), __LINE__);
        }
        $this->Device_No = $device_No;
        return $this;
    }
    /**
     * Get License_Plate value
     * @return string|null
     */
    public function getLicense_Plate()
    {
        return $this->License_Plate;
    }
    /**
     * Set License_Plate value
     * @param string $license_Plate
     * @return \StructType\SpeedAlarmElements
     */
    public function setLicense_Plate($license_Plate = null)
    {
        // validation for constraint: string
        if (!is_null($license_Plate) && !is_string($license_Plate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($license_Plate)), __LINE__);
        }
        $this->License_Plate = $license_Plate;
        return $this;
    }
    /**
     * Get Driver value
     * @return string|null
     */
    public function getDriver()
    {
        return $this->Driver;
    }
    /**
     * Set Driver value
     * @param string $driver
     * @return \StructType\SpeedAlarmElements
     */
    public function setDriver($driver = null)
    {
        // validation for constraint: string
        if (!is_null($driver) && !is_string($driver)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($driver)), __LINE__);
        }
        $this->Driver = $driver;
        return $this;
    }
    /**
     * Get Address value
     * @return string|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param string $address
     * @return \StructType\SpeedAlarmElements
     */
    public function setAddress($address = null)
    {
        // validation for constraint: string
        if (!is_null($address) && !is_string($address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($address)), __LINE__);
        }
        $this->Address = $address;
        return $this;
    }
    /**
     * Get Km_Counter value
     * @return string|null
     */
    public function getKm_Counter()
    {
        return $this->Km_Counter;
    }
    /**
     * Set Km_Counter value
     * @param string $km_Counter
     * @return \StructType\SpeedAlarmElements
     */
    public function setKm_Counter($km_Counter = null)
    {
        // validation for constraint: string
        if (!is_null($km_Counter) && !is_string($km_Counter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($km_Counter)), __LINE__);
        }
        $this->Km_Counter = $km_Counter;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\SpeedAlarmElements
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SpeedAlarmElements
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
